import { jsxs as rt, jsx as g } from "react/jsx-runtime";
import { o as st } from "../../chunks/useMergeRefs.DYDIMIZh.js";
import { y as at, i as ot, j as ct } from "../../chunks/index.B0ddvX14.js";
import lt, { useState as F, useRef as k, useLayoutEffect as E } from "react";
import { TEXT_AREA_WRAPPER_CLASSNAME as nt, r as it, TEXT_AREA_CLASSNAME as W, TEXT_AREA_CONTROL_RIGHT_CLASSNAME as ut, TEXT_AREA_HELPER_TEXT_CLASSNAME as I } from "../../chunks/constants.D-rfPeOH.js";
import c from "clsx";
function dt({
  value: t,
  defaultValue: s,
  finalValue: e,
  onChange: r = () => {
  }
}) {
  const [a, x] = F(
    s !== void 0 ? s : e
  );
  return t !== void 0 ? [t, r, !0] : [a, (n) => {
    x(n), r == null || r(n);
  }, !1];
}
const ft = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", pt = ({
  mode: t
}) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), xt = ({
  focusMode: t
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), yt = ({
  noBorder: t,
  error: s
}) => c("border-2", {
  "border-border-dark": !t && !s,
  "focus:border-border-dark": !t && s,
  "border-border-error-dark": !t && s,
  "border-transparent": t
}), ht = ({
  disabled: t,
  raw: s,
  error: e,
  mode: r
}) => {
  if (s)
    return "";
  if (t)
    return c("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!e)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-medium": r === "system",
      "text-copy-medium dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light": r === "system",
      "text-copy-medium dark:text-copy-error-dark": r === "alt-system"
    });
}, gt = ({
  error: t,
  raw: s,
  mode: e,
  disabled: r
}) => {
  if (s)
    return "";
  if (r)
    return c(
      I,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!t)
    return c(I, "absolute px-2 font-medium", {
      "text-copy-medium": e === "dark",
      "text-copy-dark": e === "light",
      "text-copy-dark dark:text-copy-medium": e === "system",
      "text-copy-medium dark:text-copy-dark": e === "alt-system"
    });
  if (t)
    return c(I, "absolute px-2 font-medium", {
      "text-copy-error-light": e === "dark",
      "text-copy-error-dark": e === "light",
      "text-copy-error-dark dark:text-copy-error-light": e === "system",
      "dark:text-copy-error-dark text-copy-error-light": e === "alt-system"
    });
}, kt = ({
  className: t,
  textAreaClassName: s,
  raw: e,
  focusMode: r,
  disabled: a,
  noBorder: x,
  error: l,
  spacing: n,
  mode: i
}) => {
  const y = e ? t : c(
    "relative flex w-full flex-col justify-center",
    nt,
    t,
    it(n)
  ), v = e ? c(s) : c(
    W,
    s,
    ft(),
    pt({ mode: i }),
    xt({ focusMode: r }),
    yt({
      noBorder: x,
      error: l
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": a
    }
  ), A = e ? void 0 : "sr-only", R = ht({
    disabled: a,
    raw: e,
    error: l,
    mode: i
  }), _ = gt({
    error: l,
    raw: e,
    mode: i,
    disabled: a
  }), u = e ? void 0 : c(ut, "absolute");
  return {
    wrapper: y,
    textArea: v,
    accessibleLabel: A,
    visibleLabel: R,
    helperText: _,
    rightElement: u
  };
}, mt = ({
  scrollHeight: t,
  currentHeight: s,
  currentLabelOffset: e = 0,
  currentHelperTextOffset: r = 0
}) => {
  let l, n;
  if (t > 0 && t !== s) {
    const i = t - s, y = Math.abs(i / 24);
    l = e + -1 * Math.sign(i) * (12 * y), n = r + Math.sign(i) * (12 * y);
  }
  return {
    labelOffset: l,
    helperTextOffset: n,
    scrollHeight: t
  };
}, At = lt.forwardRef(
  ({
    id: t,
    name: s,
    label: e,
    error: r = !1,
    raw: a = !1,
    className: x,
    textAreaClassName: l,
    mode: n = "system",
    focusMode: i = "system",
    value: y,
    defaultValue: v,
    disabled: A = !1,
    noBorder: R = !1,
    labelId: _,
    helperText: u = "",
    helperTextOnFocus: L = !1,
    rightElement: N,
    onChange: P,
    onFocus: $,
    onBlur: j,
    spacing: V,
    ...w
  }, z) => {
    const d = k(null), B = st([z, d]), [D, b] = at(), C = k(80), M = k(-25), p = k(null), X = k(30), T = k(null), m = ot({ id: t, prefix: `${W}-` }), [U, q] = F(0), [J, G] = F(
      !!(!L && u)
    ), K = `${s} error, ${u}`, h = kt({
      className: x,
      textAreaClassName: l,
      error: r,
      raw: a,
      focusMode: i,
      disabled: A,
      noBorder: R,
      spacing: V,
      mode: n
    }), [f, Q] = dt({
      value: y,
      defaultValue: v,
      onChange: (o) => {
        P && P({
          target: {
            value: o
          }
        });
      }
    }), Y = (o) => {
      Q(o.target.value);
    }, Z = (o) => {
      L && u && G(!0), $ && $(o);
    }, tt = (o) => {
      L && u && !f && G(!1), j && j(o);
    };
    return E(() => {
      b && b.width && q(b.width + 18 + 10);
    }, [b]), E(() => {
      a || d && d.current && f !== void 0 && (d.current.style.height = "inherit", d.current.style.height = d.current.scrollHeight + "px");
    }, [f, a]), E(() => {
      a || setTimeout(() => {
        var o;
        (o = p == null ? void 0 : p.current) == null || o.style.setProperty(
          "--av-text-area-wrapper-transition",
          f ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [f, a]), E(() => {
      var o, O;
      if (!a && d && d.current && f !== void 0) {
        const { labelOffset: S, helperTextOffset: H, scrollHeight: et } = mt({
          scrollHeight: d.current.scrollHeight,
          currentHeight: C.current,
          currentLabelOffset: M.current,
          currentHelperTextOffset: X.current
        });
        S && (M.current = S, (o = p == null ? void 0 : p.current) == null || o.style.setProperty(
          "--av-text-area-label",
          `${S}px`
        )), H && (X.current = H, (O = T == null ? void 0 : T.current) == null || O.style.setProperty(
          "--av-text-area-helper-text",
          `${H}px`
        )), C.current = et || C.current;
      }
    }, [f, a]), /* @__PURE__ */ rt("div", { className: h.wrapper, children: [
      /* @__PURE__ */ g(
        "label",
        {
          htmlFor: m,
          id: _,
          className: h.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ g(
        "textarea",
        {
          ref: B,
          id: m,
          name: s,
          disabled: A,
          placeholder: a ? void 0 : " ",
          className: h.textArea,
          rows: 1,
          ...u && { "aria-describedby": `${m}-helper` },
          ...r && { "aria-invalid": "true" },
          ...N && !a && { style: { paddingRight: U } },
          value: f,
          onChange: Y,
          onFocus: Z,
          onBlur: tt,
          ...w
        }
      ),
      !a && /* @__PURE__ */ g(
        "label",
        {
          ref: p,
          "aria-hidden": !0,
          htmlFor: m,
          className: h.visibleLabel,
          children: e
        }
      ),
      J && /* @__PURE__ */ g(
        "div",
        {
          ref: T,
          id: `${m}-helper`,
          className: h.helperText,
          children: u
        }
      ),
      N && /* @__PURE__ */ g(
        "div",
        {
          ref: D,
          className: h.rightElement,
          children: N
        }
      ),
      r && u && /* @__PURE__ */ g(ct, { politeness: "polite", clearAnnouncementDelay: 500, children: K })
    ] });
  }
);
At.displayName = "TextArea";
export {
  At as TextArea
};
